//+-----------------------------------------------------------------------+
//|                                                               Net.mq4 |
//|     limit-.                  |
//|  Lot    .           |
//|        |
//|   .                                             |
//+-----------------------------------------------------------------------+
#property copyright "Copyright  2011, Verdi"
#property link      "nemo811@mail.ru"
#property show_inputs
//--------------------------------------------------------------------
extern int     delta       = 20;     // 
extern int     MaxOrders   = 7;      //- limit- 
extern int     takeprofit  = 20;     //  TP,  0,  TP                 
extern int     zero_tp     = 1;      //  takeprofit     ,  0,  takeprofit    
extern int     stoploss    = 0;      //  SL,  0,  SL  
extern int     Magic       = 0;      //    
extern bool    BUY         = false;  //  BUY    BUY LIMIT
extern bool    SELL        = false;  //  SELL    SELL LIMIT
extern double  Lot         = 0.1;    //     limit-
//--------------------------------------------------------------------
double SL,TP,Price;
//--------------------------------------------------------------------
int start()
{
   for (int x=1; x<=1; x++)
   {
      if (BUY)
      {
         if (takeprofit!=0) TP  = NormalizeDouble(Ask + takeprofit*Point,Digits); else TP=0;
         if (stoploss!=0)   SL  = NormalizeDouble(Ask - stoploss*Point,Digits); else SL=0;     
         OPENORDER ("Buy",Price,SL,TP,x);
      }
      if (SELL)
      {  
         if (takeprofit!=0) TP = NormalizeDouble(Bid - takeprofit*Point,Digits); else TP=0;
         if (stoploss!=0)   SL = NormalizeDouble(Bid + stoploss*Point,Digits);  else SL=0;              
         OPENORDER ("Sell",Price,SL,TP,x);
      }
   }
   for (int i=1; i<=MaxOrders; i++)
   {
      if (BUY)
      {
         Price = NormalizeDouble(Ask-delta*i*Point,Digits);
         if (takeprofit!=0) TP  = NormalizeDouble(Price + (takeprofit + delta*i*zero_tp/3)*Point,Digits); else TP=0;
         if (stoploss!=0)   SL  = NormalizeDouble(Price - stoploss*Point,Digits); else SL=0;     
         OPENORDER ("Buy Limit",Price,SL,TP,i);
      }
      if (SELL)
      {  
         Price = NormalizeDouble(Bid+delta*i*Point,Digits);
         if (takeprofit!=0) TP = NormalizeDouble(Price - (takeprofit + delta*i*zero_tp/3)*Point,Digits); else TP=0;
         if (stoploss!=0)   SL = NormalizeDouble(Price + stoploss*Point,Digits);  else SL=0;              
         OPENORDER ("Sell Limit",Price,SL,TP,i);
      }
   }
return(0);
}
//--------------------------------------------------------------------
void OPENORDER(string ord,double Price,double SL,double TP,int i)
{
   int ticket = -1;
   int err;
   while (ticket<0)
   {
      if (ord=="Buy") ticket=OrderSend(Symbol(),OP_BUY, Lot,NormalizeDouble(Ask,Digits),3,SL,TP,"Magic_" + Magic,Magic,0);
      if (ord=="Sell") ticket=OrderSend(Symbol(),OP_SELL,Lot,NormalizeDouble(Bid,Digits),3,SL,TP,"Magic_" + Magic,Magic,0);
      if (ord=="Buy Limit") ticket=OrderSend(Symbol(),OP_BUYLIMIT, Lot*i,Price,3,SL,TP,StringConcatenate(""+i,"  Magic_" + Magic),Magic,0);
      if (ord=="Sell Limit") ticket=OrderSend(Symbol(),OP_SELLLIMIT,Lot*i,Price,3,SL,TP,StringConcatenate(""+i,"  Magic_" + Magic),Magic,0);
      Message(Magic);
      if (ticket==-1)
      {  
         ShowERROR();
         err++;Sleep(2000);RefreshRates();
      }
      if (ticket!=-1 || err >10) return;
   }
return;
}                  
//--------------------------------------------------------------------
void Message(string Magic) {
  Comment("Magic_" + Magic);
  Print("Magic_" + Magic);
}                                      
//--------------------------------------------------------------------
void ShowERROR()
{
   int err=GetLastError();
   switch ( err )
   {                  
      case 1:   return;
      case 2:   Alert("     ",Symbol());return;
      case 3:   Alert("Error   ",Symbol());return;
      case 130: Alert("Error     Ticket ",Symbol());return;
      case 134: Alert("    ",Symbol());return;
      case 146: Alert("Error    ",Symbol());return;
      case 129: Alert("Error   ",Symbol());return;
      case 131: Alert("Error   ",Symbol());return;
      case 4200:Alert("Error    ",Symbol());return;
      default:  Alert("Error  " ,err," ",Symbol());return;
   }
}
//--------------------------------------------------------------------

